var svgcity;
var currentZoom;
var initialZoom;
var maxZoom = 5;
var tutorial_step=1;
var clockMinutes = 30;
var busAnimationDuration = 60000;
var walkDuration = 60000;
var shownBusRoute = false;
var selectionTutorialStep = 1;
var studentsHaveSelectedVehicle = 0;
var isMinimized = false;
var isOpenVehicleChooser = false;

var path, motionPath;

//top message introduction tutorial total steps.
var tutorialSteps = 7;

var didNotMakeIt = 0;

var totalPollution = 0;
var usedCar = 0;
var usedMoto = 0;
var usedBike = 0;
var usedBus = 0;
var usedWalking = 0;
var usedCarpool = 0;

var students= {
    1: {
        name: 'Νικόλας',
        description: 'Ο Νικόλας μένει αρκετά μακριά από το σχολείο. Έχει πολλούς φίλους. Μάλιστα κάποιες φορές ο πατέρας του παίρνει μαζί τη Δέσποινα και τον Δημήτρη και τους πηγαίνει όλους μαζί στο σχολείο με το αυτοκίνητο.',
        selection: null,
        canCarpool: false,
        canBus: true,
        canCar: true,
        canBike: false,
        canMoto: true,
        carDuration: 25000,
        motoDuration: 22000,
        bikeDuration: 40000,
        walkDuration: walkDuration,
        canMakeItWalking: false
    },
    2: {
        name: 'Δέσποινα',
        description: 'Η Δέσποινα είναι φίλη του Νικόλα και της Λάουρας. Της αρέσει το μπαλέτο και τρώει πολλά παγωτά! Κάποιες φορές όταν πηγαίνει ο Νικόλας με το αυτοκίνητο στο σχολείο, περνάει και την παίρνει αυτός από το σπίτι και εφαρμόζουν συνεπιβατισμό.',
        selection: null,
        canCarpool: true,
        canBus: false,
        canCar: true,
        canBike: false,
        canMoto: false,
        carDuration: 20000,
        motoDuration: 18000,
        bikeDuration: 30000,
        walkDuration: walkDuration,
        canMakeItWalking: false
    },
    3: {
        name: 'Δημήτρης',
        description: 'Ο Δημήτρης είναι ο κολλητός του Νικόλα και φίλος της Δέσποινας. Κάθε απόγευμα παίζουν παρέα στο μεγάλο πάρκο πίσω από το σπίτι του. Μερικές φορές, όταν πηγαίνει ο Νικόλας με το αυτοκίνητο στο σχολείο, περνάει και τον παίρνει αυτός από το σπίτι και εφαρμόζουν συνεπιβατισμό.',
        selection: null,
        canCarpool: true,
        canBus: true,
        canCar: false,
        canBike: false,
        canMoto: true,
        carDuration: 13000,
        motoDuration: 11000,
        bikeDuration: 20000,
        walkDuration: walkDuration,
        canMakeItWalking: true
    },
    4: {
        name: 'Αγγελική',
        description: 'Η Αγγελική είναι η καλύτερη μαθήτρια στην τάξη της. Μένει σχετικά μακριά από το σχολείο. Ωστόσο πολλές φορές πηγαίνει με την μητέρα της με το αυτοκίνητο στο σχολείο και κάποιες φορές παίρνει μαζί και τις φίλες της που μένουν κοντά, εφαρμόζοντας συνεπιβατισμό.',
        selection: null,
        canCarpool: false,
        canBus: true,
        canCar: true,
        canBike: true,
        canMoto: false,
        carDuration: 18000,
        motoDuration: 16000,
        bikeDuration: 30000,
        walkDuration: walkDuration,
        canMakeItWalking: false
    },
    5: {
        name: 'Γεωργία',
        description: 'Η Γεωργία είναι φίλη της Αγγελικής και τους αρέσει πολύ να παίζουν βόλει. Μένει σχετικά κοντά στο σχολείο και κάποιες φορές πηγαίνουν παρέα στο σχολείο με το αυτοκίνητο της μητέρας της Αγγελικής.',
        selection: null,
        canCarpool: true,
        canBus: true,
        canCar: true,
        canBike: false,
        canMoto: true,
        carDuration: 15000,
        motoDuration: 13000,
        bikeDuration: 25000,
        walkDuration: walkDuration,
        canMakeItWalking: false
    },
    6: {
        name: 'Αναστασία',
        description: 'Η Αναστασία μένει πιο κοντά από όλους στο σχολείο! Είναι φίλες με την Γεωργία και την Αγγελική και της αρέσει να πηγαίνουν παρέα στο σχολείο.',
        selection: null,
        canCarpool: true,
        canBus: true,
        canCar: false,
        canBike: false,
        canMoto: true,
        carDuration: 11000,
        motoDuration: 10000,
        bikeDuration: 20000,
        walkDuration: walkDuration,
        canMakeItWalking: true
    },
    7: {
        name: 'Κώστας',
        description: 'Ο Κώστας μένει σε μια καινούρια πολυκατοικία, σχετικά μακριά από το σχολείο. Του αρέσει να παίζει ποδόσφαιρο στο πάρκο που είναι δίπλα στο σπίτι του!',
        selection: null,
        canCarpool: false,
        canBus: false,
        canCar: true,
        canBike: false,
        canMoto: true,
        carDuration: 16000,
        motoDuration: 13000,
        bikeDuration: 30000,
        walkDuration: walkDuration,
        canMakeItWalking: false
    },
    8: {
        name: 'Διονύσης',
        description: 'Ο Διονύσης είναι ο καλύτερος μαθητής στην τάξη του. Του αρέσουν πολύ οι μηχανές και θέλει να γίνει οδηγός αγώνων όταν μεγαλώσει!',
        selection: null,
        canCarpool: false,
        canBus: false,
        canCar: false,
        canBike: true,
        canMoto: true,
        carDuration: 8000,
        motoDuration: 7000,
        bikeDuration: 15000,
        walkDuration: walkDuration,
        canMakeItWalking: true
    },
    9: {
        name: 'Λάουρα',
        description: 'Η Λάουρα κάνει παρέα με τη Δέσποινα. Της αρέσει να παίζει πιάνο ενώ συχνά μαζεύονται στο σπίτι της με την παρέα της για να τραγουδήσουν.',
        selection: null,
        canCarpool: false,
        canBus: true,
        canCar: true,
        canBike: false,
        canMoto: true,
        carDuration: 16000,
        motoDuration: 13000,
        bikeDuration: 30000,
        walkDuration: walkDuration,
        canMakeItWalking: false
    },
    10: {
        name: 'Γιώργος',
        description: 'Ο Γιώργος μένει δίπλα σε μια όμορφη λίμνη. Δεν είναι και πολύ κοντά στο σχολείο. Του αρέσουν πολύ τα χειμερινά σπορ όπως το σκι και θέλει να γίνει αθλητής!',
        selection: null,
        canCarpool: false,
        canBus: false,
        canCar: true,
        canBike: true,
        canMoto: true,
        carDuration: 20000,
        motoDuration: 18000,
        bikeDuration: 25000,
        walkDuration: walkDuration,
        canMakeItWalking: false
    }
};

$(window).load(function() {

    tippy('[data-tippy-content]');

    initializeFrameZoomPan();

    $('#svg-pan-zoom-zoom-in').on('click', function(){
        if (currentZoom < maxZoom) {
            currentZoom += 0.5;
            svgcity.zoom(currentZoom);
        }
    });
    $('#svg-pan-zoom-zoom-out').on('click', function(){
        if (currentZoom < maxZoom) {
            currentZoom -= 0.5;
            svgcity.zoom(currentZoom);
        }
    });
    $('#svg-pan-zoom-reset-pan-zoom').on('click', function(){
        currentZoom = 1;
        svgcity.reset();
    });

    $(window).resize(function(){
        svgcity.resize();
        svgcity.fit();
        svgcity.center();
    });

});

$(document).ready(function(){

    $('#Child1Mark').mouseenter(function(){$('#Child1Name').removeClass('hiddenName');}).mouseleave(function(){$('#Child1Name').addClass('hiddenName');});
    $('#Child2Mark').mouseenter(function(){$('#Child2Name').removeClass('hiddenName');}).mouseleave(function(){$('#Child2Name').addClass('hiddenName');});
    $('#Child3Mark').mouseenter(function(){$('#Child3Name').removeClass('hiddenName');}).mouseleave(function(){$('#Child3Name').addClass('hiddenName');});
    $('#Child4Mark').mouseenter(function(){$('#Child4Name').removeClass('hiddenName');}).mouseleave(function(){$('#Child4Name').addClass('hiddenName');});
    $('#Child5Mark').mouseenter(function(){$('#Child5Name').removeClass('hiddenName');}).mouseleave(function(){$('#Child5Name').addClass('hiddenName');});
    $('#Child6Mark').mouseenter(function(){$('#Child6Name').removeClass('hiddenName');}).mouseleave(function(){$('#Child6Name').addClass('hiddenName');});
    $('#Child7Mark').mouseenter(function(){$('#Child7Name').removeClass('hiddenName');}).mouseleave(function(){$('#Child7Name').addClass('hiddenName');});
    $('#Child8Mark').mouseenter(function(){$('#Child8Name').removeClass('hiddenName');}).mouseleave(function(){$('#Child8Name').addClass('hiddenName');});
    $('#Child9Mark').mouseenter(function(){$('#Child9Name').removeClass('hiddenName');}).mouseleave(function(){$('#Child9Name').addClass('hiddenName');});
    $('#Child10Mark').mouseenter(function(){$('#Child10Name').removeClass('hiddenName');}).mouseleave(function(){$('#Child10Name').addClass('hiddenName');});

    $('#fullscreen-toggle').click(function(){
       if(screenfull.isFullscreen){
           screenfull.exit();
       } else {
           if (screenfull.enabled) {
               screenfull.request();
           }
       }
    });

    $('#info-button').click(function(){
      if ($('.info-container').length == 0) {
        var html = '<div class="iframe-container info-container">\n' +
          '        <div class="close-iframe"><img src="assets/close.svg" class="close-button-x"></div>\n' +
          '        <iframe src="info.html" class="info-iframe"></iframe>\n' +
          '    </div>';
        $('.container').append(html);

        $('.close-iframe').click(function(){
           $('.iframe-container').remove();
        });
      }
    });

    $('#help-button').click(function(){
        if ($('.top-message').length == 0) {
          var html = '<div class="top-message">\n' +
            '\t\t<div class="top-message-carousel owl-carousel owl-loaded owl-drag">\n' +
            '\t\t\t\n' +
            '\t\t\t\n' +
            '\t\t\t\n' +
            '\t\t\t\n' +
            '            \n' +
            '            \n' +
            '\n' +
            '\t\t<div class="owl-stage-outer"><div class="owl-stage" style="transform: translate3d(0px, 0px, 0px); transition: all 0s ease 0s; width: 4080px; padding-left: 30px; padding-right: 30px;"><div class="owl-item active" style="width: 640px; margin-right: 30px;"><div>\n' +
            '\t\t\t\t<div class="message-title">Καλωσόρισες στη Ροδούπολη!</div>\n' +
            '\t\t\t\t<div class="message-text">\n' +
            '\t\t\t\t\tΣε αυτή την πόλη υπάρχουν 10 μαθητές και μαθήτριες που πηγαίνουν κάθε πρωί στο σχολείο.\n' +
            '\t\t\t\t\tΘα πρέπει να βοηθήσεις τα 10 παιδιά να φτάσουν στο σχολείο τους με το μικρότερο δυνατό οικολογικό αποτύπωμα.\n' +
            '                    Δηλαδή παράγοντας συνολικά όσο γίνεται λιγότερους ρύπους, ίσως και χωρίς ρύπους. Γίνεται;\n' +
            '\t\t\t\t\tΕπίλεξε τον κατάλληλο τρόπο μετακίνησης για κάθε παιδί και βοήθησε τα να φτάσουν στο σχολείο στην ώρα τους! Μπορείς;\n' +
            '                    <img style="margin-top: 20px;" src="assets/slide1-image.png">\n' +
            '\t\t\t\t</div>\n' +
            '\t\t\t</div></div><div class="owl-item" style="width: 640px; margin-right: 30px;"><div>\n' +
            '\t\t\t\t<div class="message-title">Τρόποι μετακίνησης</div>\n' +
            '\t\t\t\t<div class="message-text">\n' +
            '                    Κάθε παιδί έχει στη διάθεσή του διαφορετικούς τρόπους μετακίνησης.\n' +
            '                    Μπορεί να μετακινηθεί με τα πόδια, με το ποδήλατο, να το μεταφέρει η μητέρα ή ο πατέρας του με το αυτοκίνητο ή το μηχανάκι.\n' +
            '                    Μπορεί, επίσης, να πάρει το λεωφορείο, αν περνάει από το σπίτι του.\n' +
            '                    Σε κάποιες περιπτώσεις υπάρχει, επιπλέον, η δυνατότητα του συνεπιβατισμού (δες την επόμενη οθόνη).\n' +
            '\t\t\t\t\t<div class="row-images">\n' +
            '\t\t\t\t\t\t<img src="assets/walk.png">\n' +
            '\t\t\t\t\t\t<img src="assets/bike.png">\n' +
            '\t\t\t\t\t\t<img src="assets/car.png">\n' +
            '\t\t\t\t\t\t<img src="assets/moto.png">\n' +
            '\t\t\t\t\t\t<img src="assets/bus.png">\n' +
            '\t\t\t\t\t</div>\n' +
            '\t\t\t\t</div>\n' +
            '\t\t\t</div></div><div class="owl-item" style="width: 640px; margin-right: 30px;"><div>\n' +
            '\t\t\t\t<div class="message-title">Τι είναι ο συνεπιβατισμός;</div>\n' +
            '\t\t\t\t<div class="message-text">\n' +
            '                    Συνεπιβατισμός, ή car-pooling όπως λέγεται στα αγγλικά, είναι μια πρακτική όπου δύο ή περισσότεροι άνθρωποι, αντί να πάνε στον προορισμό τους με διαφορετικά αυτοκίνητα, χρησιμοποιούν μόνο ένα. Έτσι μοιράζονται τα έξοδα αλλά υπάρχουν και άλλα οφέλη (π.χ. για το περιβάλλον).\n' +
            '                    Στην πόλη μας, λοιπόν, κάποια παιδιά μπορεί να τα μεταφέρει στο σχολείο ο γονιός ενός φίλου ή μιας φίλης.\n' +
            '\n' +
            '                    <img style="margin-top: 20px;" src="assets/carpooling.png">\n' +
            '\t\t\t\t</div>\n' +
            '\t\t\t</div></div><div class="owl-item" style="width: 640px; margin-right: 30px;"><div>\n' +
            '\t\t\t\t<div class="message-title">Πρέπει να προλάβεις το κουδούνι!</div>\n' +
            '\t\t\t\t<div class="message-text">\n' +
            '                    Η ώρα είναι 07:30 και κάθε παιδί έχει μόνο μισή ώρα για να φτάσει στο σχολείο. Αφού επιλέξεις τον τρόπο μετακίνησης για κάθε παιδί, πάτησε play για να ξεκινήσει να μετρά ο χρόνος.\n' +
            '\t\t\t\t\t<img style="margin-top: 20px;" src="assets/school-bell.png">\n' +
            '\t\t\t\t</div>\n' +
            '\t\t\t</div></div><div class="owl-item" style="width: 640px; margin-right: 30px;"><div>\n' +
            '                <div class="message-title">Πώς να περιηγηθείς στην πόλη...</div>\n' +
            '                <div class="message-text">\n' +
            '                    Για να περιηγηθείς στην πόλη μπορείς να κάνεις zoom με τη ροδέλα του ποντικιού σου, έπειτα να κάνεις κλικ σε κάποιο σημείο της πόλης και να σύρεις το ποντίκι σου για να μετακινήσεις το τμήμα της πόλης που φαίνεται στην οθόνη σου.\n' +
            '                    Επίσης μπορείς να χρησιμοποιήσεις τα εργαλεία μεγέθυνσης που υπάρχουν κάτω δεξιά στην οθόνη σου.\n' +
            '\n' +
            '                    <img style="margin-top: 20px;" src="assets/navigation.png">\n' +
            '                </div>\n' +
            '            </div></div><div class="owl-item" style="width: 640px; margin-right: 30px;"><div>\n' +
            '                <div class="message-title">Ας δούμε τη διαδρομή του λεωφορείου!</div>\n' +
            '                <div class="message-text">\n' +
            '                    Το λεωφορείο ακολουθεί συγκεκριμένη διαδρομή και φτάνει στο σχολείο πάντα έγκαιρα. Μπορεί να το χρησιμοποιήσει ένα παιδί μόνο αν περνάει έξω από το σπίτι του.\n' +
            '                    Πάτησε το κουμπί ΤΕΛΟΣ για να δεις τη διαδρομή του λεωφορείου και να αποφασίσεις αν και ποια παιδιά θα το χρησιμοποιήσουν. Η διαδρομή εμφανίζεται στον χάρτη με μωβ γραμμή.\n' +
            '\n' +
            '                    <img style="margin-top: 20px;" src="assets/bus-nav.png">\n' +
            '                </div>\n' +
            '            </div></div></div></div><div class="owl-nav disabled"><button type="button" role="presentation" class="owl-prev"><span aria-label="Previous">‹</span></button><button type="button" role="presentation" class="owl-next"><span aria-label="Next">›</span></button></div><div class="owl-dots"><button role="button" class="owl-dot active"><span></span></button><button role="button" class="owl-dot"><span></span></button><button role="button" class="owl-dot"><span></span></button><button role="button" class="owl-dot"><span></span></button><button role="button" class="owl-dot"><span></span></button><button role="button" class="owl-dot"><span></span></button></div></div>\n' +
            '\t\t<div class="button-prev is_hidden"><img src="assets/arrow-left-circle.svg"><div class="button-text">ΠΡΟΗΓΟΥΜΕΝΟ</div></div>\n' +
            '\t\t<div class="button-next"><div class="button-text">ΕΠΟΜΕΝΟ</div><img src="assets/arrow-right-circle.svg"></div>\n' +
            '\t</div>';

            $('.container').append(html);

            //initialize controls for top message owl carousel
            initTopMessage();

          }   
    });

    $('#play-button').click(function(){
        if (studentsHaveSelectedVehicle === 10){
            clockTicking();
            showRoutes();
        } else {

            const wrapper = document.createElement('div');
            wrapper.innerHTML = '<p>Δεν έχεις επιλέξει τρόπο μετακίνησης για όλα τα παιδιά... Κάνε κλικ σε όποιο παιδί δεν έχει επιλέξει τρόπο μετακίνησης. </p><img src="assets/green-check.png" style="max-width: 170px;"><p> Το πράσινο τικ μπορεί να σε βοηθήσει να δεις για ποιά παιδιά έχεις ήδη επιλέξει!</p>';
            swal({title: 'Ουπς!', content: wrapper, icon: 'warning'});
        }
    });


    $('#playgame').click(function(){
        $('.intro').removeClass('jello').addClass('fadeOut faster').delay(1000).queue(function(next){
            $('.intro').remove();
            next();
        });
        swal({
          icon: 'info',
          title: 'Πλήρης Οθόνη;',
          text: 'Μήπως θα ήθελες να ανοίξεις το παιχνίδι σε λειτουργία πλήρους οθόνης; Θα είναι περισσότερο απολαυστικό!',
          buttons: {
            confirm: {
              text: "Ναι! Τέλεια ιδέα!",
              value: true,
              visible: true,
              className: "go-fullscreen-ok",
              closeModal: true
            },
            cancel: {
              text: "Όχι...",
                value: null,
                visible: true,
                className: "go-fullscreen-cancel",
                closeModal: true,
            }
          }
        }).then(function(result) {
            $('.blurred').removeClass('blurred');
            if(result){
              if (screenfull.enabled) {
                screenfull.request();
              }
            }
        });

    });

    //initialize top message owl carousel
    initTopMessage();
});

function initTopMessage(){
  var owl = $(".top-message-carousel")

  owl.owlCarousel({
    // animateOut: 'fadeOut',
    // animateIn: 'fadeIn',
    items:1,
    margin:30,
    stagePadding:30,
    smartSpeed:450
  });

  tutorial_step = 1;

  $('.button-next').click(function(){
    owl.trigger('next.owl.carousel');
    tutorial_step ++;
    if(tutorial_step>1){
      $('.button-prev').removeClass('is_hidden');
      if(tutorial_step === tutorialSteps - 1 ){
        $('.button-next .button-text').text('ΤΕΛΟΣ');
      }
    }
    if(tutorial_step === tutorialSteps){
      $('.top-message').addClass('fadeOut faster').delay(1000).queue(function(next) {
        if (!shownBusRoute){
            showBusRoute();
            shownBusRoute = true;
        }
        $(this).remove();
        next();
      });
    }
  });

  $('.button-prev').click(function(){
    owl.trigger('prev.owl.carousel');
    tutorial_step --;
    if(tutorial_step===1){
      $('.button-prev').addClass('is_hidden');
    }
    if(tutorial_step !== tutorialSteps - 1) {
      $('.button-next .button-text').text('ΕΠΟΜΕΝΟ');
    }
  });
}

function initializeFrameZoomPan(){
    //to limit the panning to always contain the graphics
    var beforePan;

    beforePan = function(oldPan, newPan){

        var stopHorizontal = false
            , stopVertical = false
            , gutterWidth = $(window).width()
            , gutterHeight = $(window).height()
            // Computed variables
            , sizes = this.getSizes()
            , leftLimit = -((sizes.viewBox.x + sizes.viewBox.width) * sizes.realZoom) + gutterWidth
            , rightLimit = sizes.width - gutterWidth - (sizes.viewBox.x * sizes.realZoom)
            , topLimit = -((sizes.viewBox.y + sizes.viewBox.height) * sizes.realZoom) + gutterHeight
            , bottomLimit = sizes.height - gutterHeight - (sizes.viewBox.y * sizes.realZoom);

        customPan = {};
        customPan.x = Math.max(leftLimit, Math.min(rightLimit, newPan.x));
        customPan.y = Math.max(topLimit, Math.min(bottomLimit, newPan.y));

        return customPan;
    };


    svgcity = svgPanZoom('#city', {
        viewportSelector: '.svg-pan-zoom_viewport'
        , panEnabled: true
        , controlIconsEnabled: false
        , zoomEnabled: true
        , dblClickZoomEnabled: false
        , mouseWheelZoomEnabled: true
        , preventMouseEventsDefault: true
        , zoomScaleSensitivity: 0.2
        , minZoom: 1
        , maxZoom: maxZoom
        , fit: false
        , contain: true
        , center: true
        , refreshRate: 'auto'
        , beforePan: beforePan
//            , beforeZoom: function(){}
//            , onZoom: function(){}
//            , beforePan: function(){}
//            , onPan: function(){}
//            , onUpdatedCTM: function(){}
//            , customEventsHandler: {}
//            , eventsListenerElement: null
    });

    initialZoom = svgcity.getZoom();
    currentZoom = initialZoom;
}

function showBusRoute() {
    var bus = $('#Bus');

    bus.attr('display', '');
    $('#BusRoute').attr('display', '');

    path = anime.path('#bus-route');

    motionPath = anime({
        targets: '#Bus',
        translateX: path('x'),
        translateY: path('y'),
        rotate: path('angle'),
        easing: 'linear',
        duration: busAnimationDuration,
        loop: false,
    });

    setTimeout(function(){
        bus.addClass('smooth-transition');
    }, 200);

    setTimeout(function(){
        bus.attr('display', 'none');
    }, busAnimationDuration - 100);

    setTimeout(function(){
        var schoolOverlay = $('#SchoolOverlay');
        schoolOverlay.attr('display', '');
        swal('Το σχολείο!', 'Μέσα στον κύκλο φαίνεται το σχολείο της πόλης. Θυμήσου ότι ο σκοπός είναι όλα τα παιδιά να φτάσουν στην ώρα τους, με το μικρότερο δυνατό οικολογικό αποτύπωμα! Λιγότερη κατανάλωση καυσίμων, λιγότεροι ρύποι! Κάνε κλικ στο κτίριο του σχολείου για να αρχίσεις.', 'info');
        $('#School').click(function(){
            schoolOverlay.addClass('fadeOut faster');
            setTimeout(function(){
                schoolOverlay.attr('display', 'none');
                $('#Student1Overlay').attr('display','');
                $('#student1-route').attr('display', '');
                swal('Ας ξεκινήσουμε!','Κάνε κλικ στο σπίτι του Νικόλα, μέσα στον κύκλο, για να διαλέξεις με ποιον τρόπο θα πάει στο σχολείο. Η πιο κοντινή διαδρομή που μπορεί να ακολουθήσει φαίνεται με ροζ χρώμα.', 'info');
                $('#Student1Home, #Child1Mark').click(function(){
                    vehicleChooserHtml(1);
                    hideStudentOverlay(1);
                });
                $('#School').unbind('click');
            }, 500);
        });

    }, 5000)

}

function hideStudentOverlay(id) {
    var sel = '#Student' + id + 'Overlay';
    $(sel).addClass('fadeOut faster');
    setTimeout(function(){
        $(sel).attr('display', 'none');
    }, 500);
}

function minimizedHtml(id){
    var minimized = '<div class="minimized-chooser fadeIn"><div class="maximize">μεγιστοποίηση</div><img class="-minimized-kid-avatar" src="assets/kid' + id + '.png"></div>';
    $('.container').append(minimized);
    $('.minimized-chooser').click(function(){
       $('.choose-vehicle').removeClass('minimized');
       isMinimized = false;
       $(this).remove();
    });
}

function vehicleChooserHtml(id) {

    if(isMinimized || isOpenVehicleChooser) return; // we must not allow to span another vehicle chooser instance if we have a minimized window or another vehicle chooser instance open already...

    var chooseVehicleHtml = `
        <div class="choose-vehicle owl-carousel is_hidden">
            <img class="kid-avatar" src="assets/kid`+id+`.png">
            <div class="minimize">ελαχιστοποίηση</div>
            <div class="kid-name">`+students[id].name+`</div>
            <div class="kid-description">`+students[id].description+`</div>
        <div class="vehicle-options">`;

    chooseVehicleHtml += students[id].canCar ? `
        <div class="vehicle car">
            <div class="vehicle-name">Αυτοκίνητο</div>
            <img class="vehicle-image" src="assets/car.png">
            <div class="vehicle-stats">
            <div class="pollution">
            <div class="icon-description">Ρύπανση</div>
            <img class="pollution-icon" src="assets/cloud-filled.svg">
            <img class="pollution-icon" src="assets/cloud-filled.svg">
            <img class="pollution-icon" src="assets/cloud-filled.svg">
            <img class="pollution-icon" src="assets/cloud-filled.svg">
            <img class="pollution-icon" src="assets/cloud.svg">
            </div>
            <div class="speed">
            <div class="icon-description">Ταχύτητα</div>
            <img class="speed-icon" src="assets/zap-filled.svg">
            <img class="speed-icon" src="assets/zap-filled.svg">
            <img class="speed-icon" src="assets/zap-filled.svg">
            <img class="speed-icon" src="assets/zap.svg">
            <img class="speed-icon" src="assets/zap.svg">
            </div>
            <div class="vehicle-description">Το αυτοκίνητο είναι ένας γρήγορος τρόπος για να φτάσεις στο σχολείο αλλά παράγει αρκετούς ρύπους!</div>
        </div>
        <div class="select-vehicle button-round" id="select-car">ΕΠΙΛΟΓΗ</div>
            </div>` : '';

    chooseVehicleHtml += students[id].canMoto ? `
            <div class="vehicle moto">
            <div class="vehicle-name">Μηχανάκι</div>
            <img class="vehicle-image" src="assets/moto.png">
            <div class="vehicle-stats">
            <div class="pollution">
            <div class="icon-description">Ρύπανση</div>
            <img class="pollution-icon" src="assets/cloud-filled.svg">
            <img class="pollution-icon" src="assets/cloud-filled.svg">
            <img class="pollution-icon" src="assets/cloud.svg">
            <img class="pollution-icon" src="assets/cloud.svg">
            <img class="pollution-icon" src="assets/cloud.svg">
            </div>
            <div class="speed">
            <div class="icon-description">Ταχύτητα</div>
            <img class="speed-icon" src="assets/zap-filled.svg">
            <img class="speed-icon" src="assets/zap-filled.svg">
            <img class="speed-icon" src="assets/zap-filled.svg">
            <img class="speed-icon" src="assets/zap-filled.svg">
            <img class="speed-icon" src="assets/zap.svg">
            </div>
            <div class="vehicle-description">Το μηχανάκι είναι γρήγορο μέσο μετακίνησης και παράγει λιγότερους ρύπους από το αυτοκίνητο.</div>
        </div><div class="select-vehicle button-round" id="select-moto">ΕΠΙΛΟΓΗ</div>
            </div>` : '';

    chooseVehicleHtml += students[id].canBus ? `

            <div class="vehicle bus">
            <div class="vehicle-name">Λεωφορείο</div>
            <img class="vehicle-image" src="assets/bus.png">
            <div class="vehicle-stats">
            <div class="pollution">
            <div class="icon-description">Ρύπανση</div>
            <img class="pollution-icon" src="assets/cloud-filled.svg">
            <img class="pollution-icon" src="assets/cloud-filled.svg">
            <img class="pollution-icon" src="assets/cloud-filled.svg">
            <img class="pollution-icon" src="assets/cloud-filled.svg">
            <img class="pollution-icon" src="assets/cloud-filled.svg">
            </div>
            <div class="speed">
            <div class="icon-description">Ταχύτητα</div>
            <img class="speed-icon" src="assets/zap-filled.svg">
            <img class="speed-icon" src="assets/zap-filled.svg">
            <img class="speed-icon" src="assets/zap.svg">
            <img class="speed-icon" src="assets/zap.svg">
            <img class="speed-icon" src="assets/zap.svg">
            </div>
            <div class="vehicle-description">Το λεωφορείο είναι αργό μέσο μετακίνησης, παράγει πολλούς ρύπους, αλλά αν χρησιμοποιηθεί από πολλά άτομα αντί για αυτοκίνητο ή μηχανάκι, μπορεί να συμβάλει στην παραγωγή συνολικά λιγότερων ρύπων.</div>
        </div><div class="select-vehicle button-round" id="select-bus">ΕΠΙΛΟΓΗ</div>
            </div>` : '';


    chooseVehicleHtml += students[id].canBike ? `
            <div class="vehicle bike">
            <div class="vehicle-name">Ποδήλατο</div>
            <img class="vehicle-image" src="assets/bike.png">
            <div class="vehicle-stats">
            <div class="pollution">
            <div class="icon-description">Ρύπανση</div>
            <img class="pollution-icon" src="assets/cloud.svg">
            <img class="pollution-icon" src="assets/cloud.svg">
            <img class="pollution-icon" src="assets/cloud.svg">
            <img class="pollution-icon" src="assets/cloud.svg">
            <img class="pollution-icon" src="assets/cloud.svg">
            </div>
            <div class="speed">
            <div class="icon-description">Ταχύτητα</div>
            <img class="speed-icon" src="assets/zap-filled.svg">
            <img class="speed-icon" src="assets/zap-filled.svg">
            <img class="speed-icon" src="assets/zap-filled.svg">
            <img class="speed-icon" src="assets/zap.svg">
            <img class="speed-icon" src="assets/zap.svg">
            </div>
            <div class="vehicle-description">Το ποδήλατο δεν παράγει καθόλου ρύπους και είναι αρκετά γρήγορο μέσο μετακίνησης διότι δεν "κολλάει" στην κίνηση.</div>
        </div>
        <div class="select-vehicle button-round" id="select-bike">ΕΠΙΛΟΓΗ</div>
            </div>` : '';

    chooseVehicleHtml += `
            <div class="vehicle walk">
            <div class="vehicle-name">Περπάτημα</div>
            <img class="vehicle-image" src="assets/walk.png">
            <div class="vehicle-stats">
            <div class="pollution">
            <div class="icon-description">Ρύπανση</div>
            <img class="pollution-icon" src="assets/cloud.svg">
            <img class="pollution-icon" src="assets/cloud.svg">
            <img class="pollution-icon" src="assets/cloud.svg">
            <img class="pollution-icon" src="assets/cloud.svg">
            <img class="pollution-icon" src="assets/cloud.svg">
            </div>
            <div class="speed">
            <div class="icon-description">Ταχύτητα</div>
            <img class="speed-icon" src="assets/zap-filled.svg">
            <img class="speed-icon" src="assets/zap.svg">
            <img class="speed-icon" src="assets/zap.svg">
            <img class="speed-icon" src="assets/zap.svg">
            <img class="speed-icon" src="assets/zap.svg">
            </div>
            <div class="vehicle-description">Το περπάτημα είναι αργός τρόπος μετακίνησης, αλλά δεν παράγει καθόλου ρύπους και κάνει καλό στην υγεία.</div>
        </div>
        <div class="select-vehicle button-round" id="select-walk">ΕΠΙΛΟΓΗ</div>
            </div>`;

    chooseVehicleHtml += students[id].canCarpool ? `
            <div class="vehicle carpool">
            <div class="vehicle-name">Συνεπιβατισμός</div>
            <img class="vehicle-image" src="assets/carpool.png">
            <div class="vehicle-stats">
            <div class="pollution">
            <div class="icon-description">Ρύπανση</div>
            <img class="pollution-icon" src="assets/cloud.svg">
            <img class="pollution-icon" src="assets/cloud.svg">
            <img class="pollution-icon" src="assets/cloud.svg">
            <img class="pollution-icon" src="assets/cloud.svg">
            <img class="pollution-icon" src="assets/cloud.svg">
            </div>
            <div class="speed">
            <div class="icon-description">Ταχύτητα</div>
            <img class="speed-icon" src="assets/zap-filled.svg">
            <img class="speed-icon" src="assets/zap-filled.svg">
            <img class="speed-icon" src="assets/zap-filled.svg">
            <img class="speed-icon" src="assets/zap.svg">
            <img class="speed-icon" src="assets/zap.svg">
            </div>
            <div class="vehicle-description">Ο συνεπιβατισμός δεν παράγει επιπλέον ρύπους καθώς το αυτοκίνητο θα κινούνταν ούτως ή άλλως.</div>
        </div>
        <div class="select-vehicle button-round" id="select-carpool">ΕΠΙΛΟΓΗ</div>
            </div>
            </div>
            </div>` : '';

    $('.container').append(chooseVehicleHtml);

    isOpenVehicleChooser = true;

    $('.minimize').click(function(){
        isMinimized = true;
        minimizedHtml(id);
        $('.choose-vehicle').addClass('minimized');
    });

    var vehicleOptionsCarousel = $('.vehicle-options');

    vehicleOptionsCarousel.owlCarousel({
        // animateOut: 'fadeOut',
        // animateIn: 'fadeIn',
        items:1,
        smartSpeed:450,
        nav: true,
        navText : ["<img class='chevron-left-nav' src='assets/chevron-left.svg'>","<img class='chevron-right-nav' src='assets/chevron-right.svg'>"]
    });


    if(students[id].canBus){
        $('#select-bus').click(function(){
           vehicleSelected(id, 'bus');
        });
    }

    if(students[id].canCarpool){
        $('#select-carpool').click(function(){
            vehicleSelected(id, 'carpool');
        });
    }

    $('#select-moto').click(function(){
        vehicleSelected(id, 'moto');
    });

    $('#select-bike').click(function(){
        vehicleSelected(id, 'bike');
    });

    $('#select-walk').click(function(){
        vehicleSelected(id, 'walk');
    });

    $('#select-car').click(function(){
        vehicleSelected(id, 'car');
    });

    var studentHome = '#Student' + id + 'Home';
    var studentMark = '#Child' + id + 'Mark';
    $(studentHome).unbind('click');
    $(studentMark).unbind('click');

}

function disableCarPool(id){
    if( id === 1 ){
        students[2].canCarpool = false;
        students[3].canCarpool = false;
    } else if( id === 4 ){
        students[5].canCarpool = false;
        students[6].canCarpool = false;
    }
}

function showStudentRoute(id){
    if(isOpenVehicleChooser || isMinimized) return; //to avoid duplicate route display
    var studentRoute = '#student' + id + '-route';
    $(studentRoute).attr('display', '');

    setTimeout(function(){
        vehicleChooserHtml(id);
    }, 500);
}

function vehicleSelected(id, selection) {

    var studentOverlay = '#Student' + id + 'Overlay';
    var studentRoute = '#student' + id + '-route';
    var studentCheckMark = '#Check' + id;
    var studentHome = '#Student' + id + 'Home';
    var studentMark = '#Child' + id + 'Mark';

    isOpenVehicleChooser = false;

    $(studentCheckMark).attr('display','')

    $(studentHome).unbind('click');
    $(studentMark).unbind('click');

    studentsHaveSelectedVehicle ++;

    $('.choose-vehicle').addClass('fadeOut faster');

    if(selection !== 'car') disableCarPool(id);

    students[id].selection = selection;

    $('#select-moto, #select-bike, #select-walk, #select-car').unbind('click');

    setTimeout(function(){
        $(studentOverlay).addClass('fadeOut faster');
        $(studentRoute).addClass('fadeOut faster');
      $('.choose-vehicle').remove();
        setTimeout(function(){
            $(studentOverlay).attr('display', 'none');
            $(studentRoute).attr('display', 'none');
            setTimeout(function(){
                if(studentsHaveSelectedVehicle < 10){

                    if(selectionTutorialStep === 1) {
                        selectionTutorialStep ++;
                        // going directly to student 4 as she also has carpooling...
                        $('#Student4Home').click(function () {
                          showStudentRoute(4);
                          hideStudentOverlay(4);
                        });
                        $('#Child4Mark').click(function(){
                           showStudentRoute(4);
                           hideStudentOverlay(4);
                        });
                        $('#Student4Overlay').attr('display', '');
                    } else if(selectionTutorialStep === 2) {
                        selectionTutorialStep ++;

                        swal('Φύγαμε...', 'Τώρα που κατάλαβες πως επιλέγεις τρόπο μετακίνησης, συνέχισε κάνοντας κλικ και στα σπίτια των υπολοίπων παιδιών!', 'success');

                        // enable all other children for selection
                        $('#Student2Home, #Child2Mark').click(function(){ showStudentRoute(2);});
                        $('#Student3Home, #Child3Mark').click(function(){ showStudentRoute(3);});
                        $('#Student5Home, #Child5Mark').click(function(){ showStudentRoute(5);});
                        $('#Student6Home, #Child6Mark').click(function(){ showStudentRoute(6);});
                        $('#Student7Home, #Child7Mark').click(function(){ showStudentRoute(7);});
                        $('#Student8Home, #Child8Mark').click(function(){ showStudentRoute(8);});
                        $('#Student9Home, #Child9Mark').click(function(){ showStudentRoute(9);});
                        $('#Student10Home, #Child10Mark').click(function(){ showStudentRoute(10);});
                    }

                } else {
                    const wrapper = document.createElement('div');
                    wrapper.innerHTML = '<p>Έχεις διαλέξει τρόπο μετακίνησης για όλα τα παιδιά. Για να ξεκινήσουν τα παιδιά και ο χρόνος να μετράει, πάτησε play (πάνω δεξιά στην οθόνη). Παρακολούθησε τα παιδιά που πηγαίνουν στο σχολείο!</p><img src="assets/play-button.png" style="max-width: 90px;">';
                    swal({title: 'Τέλεια!', content: wrapper, icon: 'success'});
                }
            }, 500);
        }, 500);
    }, 500);

    $('.no-student-selection').removeClass('no-student-selection');

    var selectionGR;
    if(selection === 'car'){
        selectionGR = 'Aυτοκίνητο'
    } else if (selection === 'moto') {
        selectionGR = 'Μηχανή';
    } else if (selection === 'bus') {
        selectionGR = 'Λεωφορείο';
    } else if (selection === 'walk') {
        selectionGR = 'Περπάτημα';
    } else if (selection === 'carpool') {
        selectionGR = 'Συνεπιβατισμός';
    } else if (selection === 'bike') {
        selectionGR = 'Ποδήλατο';
    }

    var selectionid = '.selection-id-'+id;

    var studentSelectionHtml = '<div class="student-selection selection-id-'+id+'" data-tippy-content="'+students[id].name+': '+selectionGR+'"><img class="kid-profile-pic" src="assets/kid'+id+'.png"><img class="kid-selection-vehicle" src="assets/'+selection+'.png"></div>';

    $('.top-selection-bar').append(studentSelectionHtml);

    tippy(document.querySelector(selectionid));
}

function resetVehiclesPosition(){
    var allVehicles = $('#Bus, #Moto1, #Moto3, #Moto5, #Moto6, #Moto7, #Moto8, #Moto9, #Moto10, #Car1, #Car2, #Car4, #Car5, #Car7, #Car9, #Car10, #Bike4, #Bike8, #Bike10, #Walk1, #Walk2, #Walk3, #Walk4, #Walk5, #Walk6, #Walk7, #Walk8, #Walk9, #Walk10');
    allVehicles.attr('display', 'none');
    allVehicles.css('transform', '');
    allVehicles.removeClass();
}

function showRoutes(){

    $('#BusRoute').attr('display', 'none');
    var bus = $('#Bus');

    bus.removeClass('smooth-transition');
    bus.attr('display', 'none');

    path = anime.path('#bus-route');

    motionPath = anime({
        targets: '#Bus',
        translateX: path('x'),
        translateY: path('y'),
        rotate: path('angle'),
        easing: 'linear',
        duration: 60000,
        loop: false
    });

    setTimeout(function(){
        bus.addClass('smooth-transition');
        bus.attr('display', '');
    }, 200);


    for (i = 1; i <= Object.keys(students).length; i++) {
        var sel = students[i].selection;
        var vehicleName;
        var mypath;
        if (sel === 'car') {
            vehicleName = '#Car'+i;
            mypath = '#student'+i+'-vehicle';
            animatePath(vehicleName, mypath, students[i].carDuration, true, true);
            usedCar++;
            totalPollution += 4;
        } else if (sel === 'moto') {
            vehicleName = '#Moto'+i;
            mypath = '#student'+i+'-vehicle';
            animatePath(vehicleName, mypath, students[i].motoDuration, true, true);
            usedMoto++;
            totalPollution += 2;
        } else if (sel === 'bike') {
            vehicleName = '#Bike'+i;
            mypath = '#student'+i+'-vehicle';
            animatePath(vehicleName, mypath, students[i].bikeDuration, true, true);
            usedBike++;
        } else if (sel === 'walk') {
            vehicleName = '#Walk'+i;
            mypath = '#student'+i+'-foot';
            animatePath(vehicleName, mypath, students[i].walkDuration, false, students[i].canMakeItWalking);
            if(!students[i].canMakeItWalking) didNotMakeIt++;
            usedWalking++;
        } else if (sel === 'bus') {
            usedBus++;
        } else if (sel === 'carpool') {
            usedCarpool++;
        }
    }
}


function animatePath(vehicleName, path, duration, smooth, hide){

    $(vehicleName).attr('display', '');

    path = anime.path(path);

    motionPath = anime({
        targets: vehicleName,
        translateX: path('x'),
        translateY: path('y'),
        rotate: path('angle'),
        easing: 'linear',
        duration: duration,
        loop: false
    });

    if(smooth){
        setTimeout(function(){
            $(vehicleName).addClass('smooth-transition');
        }, 200);
    }

    if(hide){
        setTimeout(function(){
           $(vehicleName).attr('display', 'none');
        }, duration+300);
    }
}

function clockTicking(){
    clockMinutes += 1;
    if(clockMinutes < 60) {
        $('.clock-minutes').text(clockMinutes);
        setTimeout(function(){
            clockTicking();
        }, 2000);
    } else {
        // the time is up.. All are completed...
        $('.clock-minutes').text('00');
        $('.clock-hours').text('08');

        calculateTotalFootprint();
    }
}

function calculateTotalFootprint(){

    var summaryTitle, summaryMainMessage, summaryImage, summarySecondaryMessage;

    var minPollution = 11; // only the bus + car for kid 2 or car for kid 1 and carpool for kid 2 + moto for child 7.
    var madeIt = 10 - didNotMakeIt;

  totalPollution += 5; // adding 5 for the bus...

    if (didNotMakeIt > 0){
      if (totalPollution > minPollution) {
        summaryTitle = 'Πρέπει να προσπαθήσεις περισσότερο...';
        summaryImage = 'assets/summary-did-not-make-it-and-not-optimal.png';
        summaryMainMessage = 'Παιδιά που κατάφεραν να φτάσουν έγκαιρα στο σχολείο: <strong>' + madeIt + '</strong> από τα <strong>10.</strong> <br>Μάλλον θα πρέπει να διαλέξεις πιο γρήγορο τρόπο μετακίνησης για αυτά!';
        summarySecondaryMessage = 'Θα μπορούσες να τα καταφέρεις και καλύτερα, επιλέγοντας τρόπους μετακίνησης που είναι περισσότερο φιλικοί προς το περιβάλλον.'
      } else {
        summaryImage = 'assets/summary-did-not-make-it.png';
        summaryTitle = 'Με λίγους ρύπους αλλά δεν πρόλαβαν...';
        summaryMainMessage = 'Παιδιά που κατάφεραν να φτάσουν έγκαιρα στο σχολείο: <strong>' + madeIt + '</strong> από τα <strong>10.</strong> <br>Μάλλον θα πρέπει να διαλέξεις πιο γρήγορο τρόπο μετακίνησης για αυτά!';
        summarySecondaryMessage = 'Έχεις πετύχει το μικρότερο δυνατό συνολικό οικολογικό αποτύπωμα. Τα παιδιά διάλεξαν μεταφορικά μέσα που παράγουν τους λιγότερους δυνατούς ρύπους. Καλύτερα δεν γίνεται σε αυτή την πόλη.'
      }
    } else {
      if (totalPollution > minPollution) {
        summaryTitle = 'Στην ώρα τους αλλά με αρκετούς ρύπους!';
        summaryImage = 'assets/summary-not-optimal.png';
        summaryMainMessage = 'Παιδιά που κατάφεραν να φτάσουν έγκαιρα στο σχολείο: <strong>10</strong> από τα <strong>10.</strong> <br>Οι τρόποι μετακίνησης που διάλεξες είναι γρήγοροι!';
        summarySecondaryMessage = 'Θα μπορούσες να τα καταφέρεις και καλύτερα επιλέγοντας τρόπους μετακίνησης που να είναι πιο φιλικοί προς το περιβάλλον.'
      } else {
        summaryTitle = 'Μπράβο!';
        summaryImage = 'assets/summary-bravo.png';
        summaryMainMessage = 'Παιδιά που κατάφεραν να φτάσουν έγκαιρα στο σχολείο: <strong>10</strong> από τα <strong>10.</strong> <br>Οι τρόποι μετακίνησης που διάλεξες είναι γρήγοροι!';
        summarySecondaryMessage = 'Έχεις πετύχει το μικρότερο δυνατό συνολικό οικολογικό αποτύπωμα. Τα παιδιά διάλεξαν τρόπους μετακίνησης που παράγουν τους λιγότερους δυνατούς ρύπους. Καλύτερα δεν γίνεται σε αυτή την πόλη.'
      }
    }

    var html = '<div class="summary">' +
        '<div class="summary-title">'+summaryTitle+'</div>' +
        '<div class="summary-main-message">'+summaryMainMessage+'</div>' +
        '<img src="'+summaryImage+'" class="summary-cover">' +
        '<div class="total-pollution"><p>Συνολική Ρύπανση:</p><div class="pollution-number">'+totalPollution+'</div><img class="pollution-icon" src="assets/cloud-filled.svg"></div>' +
        '<div class="summary-main-message">'+summarySecondaryMessage+'</div>' +
        '<div class="button-replay"><div class="button-text">ΠΑΙΞΕ ΞΑΝΑ!</div><img src="assets/repeat.svg"></div>' +
    '</div>';

  $('.container').addClass('blurred');
  $('body').append(html);
  $('.button-replay').click(function(){
      // location.reload();
      replayGame();
  });
}

function replayGame(){
    totalPollution = 0;
    didNotMakeIt = 0;
    usedCar = 0;
    usedBike = 0;
    usedMoto = 0;
    usedBus = 0;
    usedWalking = 0;
    usedCarpool = 0;
    selectionTutorialStep = 1;
    studentsHaveSelectedVehicle = 0;

    $('.summary').remove();
    $('.container').removeClass('blurred');
    $('.top-selection-bar').empty().addClass('no-student-selection');
    $('#Check1, #Check2, #Check3, #Check4, #Check5, #Check6, #Check7, #Check8, #Check9, #Check10').attr('display', 'none');

    for (i = 1; i <= Object.keys(students).length; i++) {
        students[i].selection = undefined;
    }

    resetVehiclesPosition();

    // we must remove all classes because fadeOut class prevents the overlay from showing...
    $('#Student1Overlay, #Student4Overlay, #student1-route, #student2-route, #student3-route, #student4-route, #student5-route, #student6-route, #student7-route, #student8-route, #student9-route, #student10-route').removeClass();

    clockMinutes = 30;
    $('.clock-minutes').text('30');
    $('.clock-hours').text('07');

    $('#BusRoute').attr('display', '');
    $('#Student1Overlay').attr('display', '');
    $('#Student1Home, #Child1Mark').click(function(){
        $(this).unbind('click');
        vehicleChooserHtml(1);
        hideStudentOverlay(1);
    });
}
